import time
import ft
txt2=ft.fttxt2()

class Devs():
  dev = None
  tname = ""
  mode = "   "
  output = None
  def __init__(self, i):
    code = txt2.dicode(i)
    mode = txt2.dimode(i)
    #print("code", code, " mode", mode)
    self.tname = txt2.typename(code)
    #print("tname", self.tname)
    self.output = self.skip
    if code == 1: # switch
       self.dev = txt2.switch(i)
       self.output = self.stateOutput
    elif code == 2: # voltage
       self.dev = txt2.voltmeter(i)
       self.output = self.stateOutput
    elif code == 3: # resistor
       self.dev = txt2.resistor(i)
       self.output = self.resistorOutput
    elif code == 4: # termistor
       self.dev = txt2.ncttermistor(i)
       self.output = self.temperatureOutput
    elif code == 5: # color_sensor
       self.dev = txt2.colorsensor(i)
       self.output = self.stateOutput
    elif code == 6: # trail_follower
       self.dev = txt2.trail_follower(i)
       self.output = self.stateOutput
    elif code == 7: # ultrasonic
       self.dev = txt2.ultrasonic(i)
       self.output = self.distanceOutput
    elif code == 8: # digital
       self.dev = txt2.digital(i)
       self.output = self.stateOutput
    else:
       output = self.skip
    if mode & 14 == 0:
       self.mode = "unk"
    elif mode & 8:
       self.mode = "ult"
    else:
        if mode & 2:
          self.mode = "d"
        else:
          self.mode = "a"
        if mode & 1:
          self.mode += "p"
        else:
          self.mode += "a"
        if mode & 16:
          self.mode += "9"
        else:
          self.mode += "5"
  def skip(self, i):
      print(i, self.mode, self.tname)
  def stateOutput(self, i):
      print(i, self.mode, self.tname.ljust(15, ' '), self.dev.state())
  def resistorOutput(self, i):
      print(i, self.mode, self.tname.ljust(15, ' '), self.dev.state(), self.dev.resistance)
  def temperatureOutput(self, i):
      print(i, self.mode, self.tname.ljust(15, ' '), self.dev.state(), self.dev.resistance, self.dev.temperature)
  def distanceOutput(self, i):
      print(i, self.mode, self.tname.ljust(15, ' '), self.dev.distance)


devs = [None] * 9
for i in range(1,9):
   devs[i]=Devs(i)

txt2.update_config()

while True:
  print("\x0c")
  for i in range(1,9):
    devs[i].output(i)
  time.sleep(0.1)







