# This test outputs a NTC termistor temperature each second
# NTC termistor must be connected to I5-GND
# Use CTRL-C to abort this test

import ftlock
import sys
if ftlock.try_lock(sys.argv[0]) < 0 :
    state = ftlock.state()
    print("Resources locked by " + state.name)
    sys.exit(1)

import time
import ft
txt2=ft.fttxt2()
l=txt2.getControllerInfoList()
if len(l) < 2:
    print("No available slaves")
    quit()
ts=txt2.getController(l[1])
n5=ts.ncttermistor(5)
ts.update_config()

ftlock.notify('R')

print("Remote NTC test")
while True:
    print("Remote temperature", n5.ntcTemperature())
    time.sleep(1)

