# This test outputs information from an ultrasonic sensor
# This sensor must be connected to I1, GND, 9V as usual
# Use CTRL-C to interrupt this test

import ftlock
import sys
if ftlock.try_lock(sys.argv[0]) < 0 :
    state = ftlock.state()
    print("Resources locked by " + state.name)
    sys.exit(1)

import time
import ft
txt2=ft.fttxt2()
l=txt2.getControllerInfoList()
ts=txt2.getController(l[1])
u1=ts.ultrasonic(1)
ts.update_config()

ftlock.notify('R')

print("Remote Ultrasonic test")
while 1:
    print(u1.distance)
    time.sleep(0.1)


